﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local p
local spname,startTime,endTime
local phealth,phealthmax,ppower,ppowermax,ppactiveRegen,pshape
--[[lib.mytest=function(tab)
	tab["a"]=2
	end
cfg.mytab={}
cfg.mytab["a"]=3

lib.mytest2=function()
	lib.mytest(cfg.mytab)
	print(cfg.mytab["a"])
end]]


local function Hedd_findclass()
	cfg.talenttree = GetSpecialization() or 4
	if lib.classes[cfg.class] and lib.classes[cfg.class][cfg.talenttree] then
		cfg.classfound=true
		return lib.classes[cfg.class][cfg.talenttree]()
	end
	cfg.classfound=nil
	return false
end

lib.basicevents = function()
	function Heddevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" then
			lib.UpdatePower(powerType)
		end
	end

	function Heddevents.UNIT_HEALTH_FREQUENT(unitID)
		if cfg.watchunits[unitID] then
			lib.UpdateHealth(unitID)
		end
	end
	
	Heddevents.SPELL_UPDATE_USABLE=lib.UpdateAllSpells
		
	function Heddevents.UNIT_AURA(unitID)
		--print(unitID)
		if unitID and cfg.watchunits[unitID] then --and UnitExists(unitID) 
			lib.UpdateAuraAll(unitID)
		end
		if unitID=="player" then
			lib.UpdateHaste()
			lib.UpdatePower()
			lib.UpdateAllSpells()
		end
		if cfg.TrackAura.spell and cfg.aura[cfg.TrackAura.spell] and cfg.aura[cfg.TrackAura.spell].unit==unitID then 
			lib.UpdateAuraFrame()
		end
	end
	
	function Heddevents.PLAYER_TARGET_CHANGED()
		lib.UpdateTarget()
		lib.UpdateTargetCast()
		Heddevents.UNIT_AURA("target")
		Heddevents.UNIT_HEALTH_FREQUENT("target")
		lib.instance()
		cfg.Update=true
	end
	
	function Heddevents.UNIT_PET(unitID)
		if unitID=="player" then
			lib.UpdatePet()
			Heddevents.UNIT_HEALTH_FREQUENT("pet")
		end
	end

	function Heddevents.PLAYER_EQUIPMENT_CHANGED(slot, hasItem)
		Heddtalents_reload()
		lib.UpdateEquip(slot)
		lib.UpdateSet()
		cfg.Update=true
	end

	function Heddevents.UNIT_SPELLCAST_START(u, spellname, rank, castid, spellID)
		if u=="target" then
			lib.UpdateTargetCast(spellID)
			return
		end
		if castid==0 then return end
		if u=="player" then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_START "..spellname.." "..spellID) end
			lib.UpdateSpell(spellID)
			lib.UpdateCast(spellID)
			lib.SwitchMode()
			lib.UpdatePower(cfg.Power.type)
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_INTERRUPTED(u, spellname, rank, castid, spellID)
		if u=="target" then
			lib.UpdateTargetCast(spellID)
			return
		end
		if castid==0 then return end
		if u=="player" then
			lib.UpdateSpell(spellID)
			if cfg.Casting.castid==castid then
				if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_INTERRUPTED "..spellname.." "..spellID) end
				lib.UpdateCast(spellID)
				lib.UpdatePower(cfg.Power.type)
				--lib.UpdateAllSpells()
			end
			cfg.Update=true
		end
	end
	
	Heddevents.UNIT_SPELLCAST_STOP=Heddevents.UNIT_SPELLCAST_INTERRUPTED
	
	function Heddevents.UNIT_SPELLCAST_DELAYED(u, spellname, rank, castid, spellID)
		if u=="target" then
			lib.UpdateTargetCast(spellID)
			return
		end
		if castid==0 then return end
		if u=="player" then
			lib.UpdateSpell(spellID)
			if cfg.Casting.castid~=castid then
				if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_DELAYED "..spellname.." "..spellID) end
				lib.UpdateCast(spellID)
				lib.UpdatePower(cfg.Power.type)
				--lib.UpdateAllSpells()
			end
			cfg.Update=true
			return
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_SUCCEEDED(u, spellname, rank, castid, spellID)
		if u=="target" then
			lib.UpdateTargetCast(spellID)
			return
		end
		if castid==0 then return end
		if u=="player" and not cfg.res_spells[spellname] then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_SUCCEEDED "..spellname.." "..spellID) end
			lib.UpdateSpell(spellID,true)
			if cfg.ischanneling and cfg.showchannel then
				Heddevents.UNIT_SPELLCAST_CHANNEL_START(u,spellname)
			else
				lib.UpdateCast(spellID)
				lib.SaveSpell(spellID)
				lib.SwitchMode()
				lib.UpdatePower(cfg.Power.type)
				cfg.Update=true
			end
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_INTERRUPTIBLE(u)
		if u=="target" then
			lib.UpdateTargetCast()
			return
		end
	end
	
	Heddevents.UNIT_SPELLCAST_NOT_INTERRUPTIBLE=Heddevents.UNIT_SPELLCAST_INTERRUPTIBLE
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_START(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_START "..spellname) end
			lib.UpdateChannel(spellID)
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_UPDATE(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_UPDATE "..spellname) end
			lib.UpdateChannel(spellID)
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.UNIT_SPELLCAST_CHANNEL_STOP(u, spellname, rank, castid, spellID)
		if u=="player" and cfg.showchannel then
			if cfg.debugspells then print(GetTime().." UNIT_SPELLCAST_CHANNEL_STOP "..spellname) end
			lib.UpdateChannel(spellID)
			lib.SaveSpell(spellID)
			lib.SwitchMode()
			cfg.Update=true
		end
	end
	
	function Heddevents.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellID,spellName,_,_,interrupt)
	if cfg.TrackDOT.spell then
		if cfg.HasDOTEvent[eventtype] then
			if spellID == cfg.aura[cfg.TrackDOT.spell].id then
				if sourceGUID == cfg.GUID["player"] then
					lib.AddTrackDOT(destGUID)
				end
			end
		elseif eventtype == "SPELL_AURA_REMOVED" then
			if spellID == cfg.aura[cfg.TrackDOT.spell].id then
				if sourceGUID == cfg.GUID["player"] then
					lib.DelTrackDOT(destGUID)
				end
			end
		elseif eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED"  then
			lib.DelTrackDOT(destGUID)
		else
			--if spellID == cfg.aura[cfg.TrackDOT.spell].id then print(eventtype) end
		end
	end
	if sourceGUID == cfg.GUID["player"] then
		if eventtype == "SPELL_CAST_SUCCESS" then
			if cfg.debugspells then print(GetTime().." COMBATLOG (SPELL_CAST_SUCCESS) "..spellName.." "..spellID) end
			if cfg.id2spell[spellID] and cfg.spells[cfg.id2spell[spellID]] then 
				cfg.spells[cfg.id2spell[spellID]].guid=destGUID
				cfg.spells[cfg.id2spell[spellID]].lastcast=GetTime()
			end
		end
	end
	end
	
	function Heddevents.PLAYER_ENTERING_WORLD()
		Heddevents.PLAYER_TARGET_CHANGED()
		for unitID,_ in pairs(cfg.watchunits) do
			if unitID~="target" then
				Heddevents.UNIT_AURA(unitID)
				Heddevents.UNIT_HEALTH_FREQUENT(unitID)
			end
		end
		Heddevents.UNIT_POWER_FREQUENT("player")
		lib.UpdateShape()
		lib.UpdateAllSpells()
--		lib.instance()
		cfg.Update=true
	end
	
	function Heddevents.PET_BATTLE_OPENING_START()
		if InCombatLockdown() then return end
		if C_PetBattles.IsInBattle() then
			lib.HideFrame(Heddframe)
		end
	end
	
	--Heddevents.PET_BATTLE_OPENING_START=Heddevents.PLAYER_CONTROL_LOST
	
	function Heddevents.PET_BATTLE_CLOSE()
		if InCombatLockdown() then return end
		if not C_PetBattles.IsInBattle() then
			lib.ShowFrame(Heddframe)
		end
	end
	
	--Heddevents.PET_BATTLE_CLOSE=Heddevents.PLAYER_CONTROL_GAINED
	
	function Heddevents.PLAYER_REGEN_DISABLED()
		lib.ShowFrame(Heddmain)
		lib.ShowFrame(Heddframe.combo)
		cfg.Update=true
	end
	
	function Heddevents.PLAYER_REGEN_ENABLED()
		lib.UpdateCast()
		if HeddDB.show=="incombat" then
			lib.HideFrame(Heddmain)
		end
		if HeddDB.combo=="incombat" then
			lib.HideFrame(Heddframe.combo)
		end
		cfg.Update=true
	end
	
	
	--[[	function Heddevents.UPDATE_SHAPESHIFT_FORM(...)
		pshape=cfg.shape
		cfg.shape=lib.shape()
		
		if cfg.shape~=pshape then
			if lib.onshapeupdate then lib.onshapeupdate() end
			cfg.Update=true
		end
	end]]
	
	--[[function Heddevents.UPDATE_SHAPESHIFT_FORM()
		lib.UpdateShape()
	end]]
end

local function Hedd_onupdate(self, elapsed)
	cfg.lastUpdate = cfg.lastUpdate + elapsed
	--cfg.now = GetTime()
	if lib.myonupdate then lib.myonupdate() end
	if lib.rangecheck then lib.rangecheck() end
	if cfg.Update or (cfg.nextUpdate>0 and cfg.nextUpdate<=GetTime()) then -- CD ending doesn't call the event!!!
		if not cfg.Update then lib.UpdateAllSpells() end
		if cfg.FindPriority then print("Finding priority!") end
		lib.SetPriority()
		cfg.FindPriority=false
		Heddmain.text:SetText(cfg.mode)
		cfg.lastUpdate = 0
		--print(GetTime().." - Updating!!!")
		cfg.Update=false
		cfg.nextUpdate=lib.GetSpellCDNext()
	end
end


cfg.loaded_1st=nil
function Heddtalents_reload(self,event,...)
	if cfg.loaded_1st and InCombatLockdown() then return end
	if event=="PLAYER_SPECIALIZATION_CHANGED" and ...~="player" then return end
	if event=="SPELLS_CHANGED" then
		Heddtalents:UnregisterEvent("SPELLS_CHANGED")
	end
	for index,name in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[index].f)
		lib.CDdel(index)
		lib.CDOptionsHide(index)
	end
	
	if not InCombatLockdown() then 
		Heddframe:Hide()
	end
	lib.HideCombo()
	
	lib.defaults()
	
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	
	local unit
	if Hedd_findclass() then
		lib.UpdateEquipAll()
		lib.basicevents()
		if lib.classevents[cfg.class] then lib.classevents[cfg.class]() end
		lib.UpdateShape()
		lib.UpdateSet()
		if lib.mytal then lib.mytal() end
		if lib.CD then lib.CD() end
		lib.common()
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(self, event, ...)
			if not cfg.classfound then return end
			if cfg.debugevents then
				print(GetTime().." - "..event.." "..((...) and (...) or "no args"))
			end
			if Heddevents[event] then Heddevents[event](...) end
			if Heddclassevents[event] then Heddclassevents[event](...) end
			
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k)
		end
		
		for k, v in pairs(Heddclassevents) do
			Heddframe:RegisterEvent(k)
		end
		
		Heddframe:SetScript("OnUpdate", Hedd_onupdate)
		
		Heddevents.PLAYER_ENTERING_WORLD()
		Heddframe:Show()
		--Heddmain.text:Show()
		cfg.loaded_1st=true
	end
	
end

cfg.notloaded=true
local function Heddframe_pew(self,...)
	if not GetSpellInfo(GetSpellInfo(6603)) then return nil end
	if not GetInventorySlotInfo("MainHandSlot") then return nil end
	
	if cfg.notloaded then
		
		cfg.notloaded=nil
		Heddframe:UnregisterAllEvents()
		Heddframe:SetScript("OnUpdate",nil)
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);

		Heddtalents:SetScript("OnEvent",Heddtalents_reload)
		Heddtalents:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
		Heddtalents:RegisterEvent("SPELLS_CHANGED")
		--Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		--Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		--Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")
		--Heddtalents:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
		
		--[[Heddtalents:SetScript("OnUpdate",function(...) 
		if (UnitOnTaxi("player") or C_PetBattles.IsInBattle()) then
			if Heddframe:IsShown() then Heddframe:Hide() end
			return
		end
		if not InCombatLockdown() and not Heddframe:IsShown() then
			Heddframe:Show() 
			return
		end
		
		end)]]
		
	end
end

--hooksecurefunc("TalentFrame_Update",function(...) print("TalentFrame_Update") end)
Heddframe:SetScript("OnEvent",Heddframe_pew)
Heddframe:SetScript("OnUpdate",Heddframe_pew)
Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")
--Heddframe:RegisterEvent("SPELLS_CHANGED")
--Heddframe:RegisterEvent("PLAYER_TALENT_UPDATE")
Heddframe.lib=lib
Heddframe.cfg=cfg

local debug_now=false
if debug_now then
Heddtestevents_frame = Heddtestevents_frame or CreateFrame("Button","HEDD_TEST_EVENTS",UIParent)
Heddtestevents_frame:Show()
Heddtestevents_frame:SetScript("OnEvent", function(self, ...)
	print(...)
	end)

for _, ev in ipairs({
--"PLAYER_CONTROL_LOST",
--"PET_BATTLE_OPENING_START",
--"PLAYER_CONTROL_GAINED",
--"PET_BATTLE_CLOSE",
--"PLAYER_REGEN_DISABLED",
--"PLAYER_REGEN_ENABLED",
--"PLAYER_SPECIALIZATION_CHANGED"

--"UNIT_SPELLCAST_START",
--"UNIT_SPELLCAST_INTERRUPTED",
--"UNIT_SPELLCAST_DELAYED",
--"UNIT_SPELLCAST_STOP",
"UNIT_AURA"
--"UNIT_SPELLCAST_SUCCEEDED"
--"PLAYER_SPECIALIZATION_CHANGED",
--"PLAYER_TALENT_UPDATE",
--"SPELLS_CHANGED",
--"PLAYER_ENTERING_WORLD"
}) do
	Heddtestevents_frame:RegisterEvent(ev)
end
end