-- get the addon namespace
local addon, ns = ...
local cfg = ns.cfg
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

local power_old={}
lib.UpdatePower = function(powerType)
	powerType=powerType or cfg.Power.type
	if cfg.Power.type~=powerType then
		lib.UpdateAltPower(powerType)
		return
	end
	hedlib.shallowCopy(cfg.Power,power_old)
	cfg.Power.now=UnitPower("player",powerType)
	cfg.Power.max=UnitPowerMax("player",powerType)
	cfg.Power.regen=(select(2,GetPowerRegen()))
	cfg.Power.real=cfg.Power.now+lib.CastingPower()
	if cfg.Power.real>cfg.Power.max then cfg.Power.real=cfg.Power.max end 
	
	if not hedlib.ArrayNotChanged(cfg.Power,power_old) then
		--print(cfg.Power.real)
		lib.UpdateAllSpells("power")
		--print(cfg.Power.regen.." "..cfg.Power.now)
		cfg.Update=true
	end
end

local castpower
lib.CastingPower = function()
	if lib.IsCasting() then
		return ((cfg.Casting.castend-GetTime())*cfg.Power.regen-lib.GetCastingSpellCost())
	end
	return 0
end

lib.Power = function()
	return math.min(cfg.Power.max,(cfg.Power.now-lib.GetCastingSpellCost()+(lib.SpellCastingLeft()*cfg.Power.regen)))
end

lib.PowerInTime = function(t)
	return math.min(cfg.Power.max,(cfg.Power.now-lib.GetCastingSpellCost()+(t*cfg.Power.regen)))
end
	
lib.PowerMax = function()
	return cfg.Power.max
end

lib.SetAltPower = function(altpower_num,local_altpower_G,nocombo,func)
	if not altpower_num or cfg.Power.type_num==altpower_num then
		return
	end
	cfg.AltPower.type_num=altpower_num
	cfg.AltPower.now=UnitPower("player",cfg.AltPower.type_num)
	cfg.AltPower.max=UnitPowerMax("player",cfg.AltPower.type_num)
	cfg.AltPower.func=func or nil
	if not nocombo then
		lib.ComboAdd(cfg.AltPower.max)
		Heddframe.combo.altpower=true
	end
	if local_altpower_G then
		cfg.AltPower.local_type=hedlib.BlizzPattern(local_altpower_G)
	end
	cfg.Update=true
end

altpower_old={}
lib.UpdateAltPower = function(powerType)
	if cfg.AltPower.type_num==cfg.Power.type_num or cfg.AltPower.type_num~=_G["SPELL_POWER_"..powerType] 
	then return end
	hedlib.shallowCopy(cfg.AltPower,altpower_old)
	cfg.AltPower.now = UnitPower("player", cfg.AltPower.type_num)
	cfg.AltPower.max=UnitPowerMax("player", cfg.AltPower.type_num)
	if not hedlib.ArrayNotChanged(cfg.AltPower,altpower_old) then
		if Heddframe.combo.altpower then
			lib.ComboSet(cfg.AltPower.now)
			if cfg.AltPower.func then cfg.AltPower.func() end
		end
		lib.UpdateAllSpells("alt")
		cfg.Update=true
	end
end

lib.MaxEnergy = function()
	return (cfg.Power.max-cfg.Power.real)/cfg.Power.regen
end

--[[lib.TimeEnergy = function(t)
	return (cfg.Power.real+cfg.Power.regen*t)
end]]

lib.Time2Power = function(power)
	--if power<cfg.Power.now then return math.max(0,lib.SpellCastingLeft()) end
	return math.max(0,lib.SpellCastingLeft(),((power-cfg.Power.now+lib.GetCastingSpellCost())/cfg.Power.regen))
end

--[[lib.Time2PowerSpell = function(spell)
	if cfg.spells[spell] and cfg.spells[spell].type=="power" then
		return math.max(0,(cfg.spells[spell].cd - (GetTime() - cfg.spells[spell].start))
	end
	return 9999
end]]

lib.TimeEnergyGain = function(t)
	return (cfg.Power.regen*t)
end
